//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT"  ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _GEPCIMCARD_
#define _GEPCIMCARD_

#ifndef _UNIIO_H
   #include "uniio.h"
#endif

#ifndef _IOCARD_
   #include "iocard.hpp"
#endif

#ifndef _PHYSMEM_
   #include "physmem.hpp"
#endif

//-----------------------------------------------------------------------------
namespace Uniio
{

class GEMicroGENI;

class _Export_UNIIO GEPCIMCard 
{

public:

   enum publicConstants
   {
       singleChannel    = 0x1
     , dualChannel      = 0x2
     // synonyms
     , ELB921           = 0x1
     , ELB922           = 0x2
   }; 

   GEPCIMCard ( const unsigned inBaseMemoryAddress
              , const unsigned inType = singleChannel
              );
   virtual ~GEPCIMCard ();

   unsigned baseIOAddress () const;
   unsigned motherboardType () const;

   GEPCIMCard & addMicroGENI ( const unsigned inIOPortAddress
                             , const unsigned long inSharedRamAddress
                             );

   GEMicroGENI * channelA ()
      {return theChannelA;}
   GEMicroGENI * channelB ()
      {return theChannelB;}

protected:


private:

   GEPCIMCard ( const GEPCIMCard &);
   GEPCIMCard & operator = ( const GEPCIMCard &);

   const unsigned theBaseIOAddress;
   const unsigned theMotherboardType;

   GEMicroGENI * theChannelA;
   GEMicroGENI * theChannelB;
}; // end GEPCIMCard class declaration

#include "gepcimcard.inl"

}; // end namespace

#endif