//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB BBDSoft ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _PCICURS_
#define _PCICURS_

#ifndef _PCIBUS_
   #include "pcibus.hpp"
#endif

#ifndef _UNIIO_H
   #include "uniio.h"
#endif


//-----------------------------------------------------------------------------
namespace Uniio
{

class _Export_UNIIO PCICursor
{
public:

   PCICursor ();

     
   bool isValid () const;
   PCICursor& first();
   PCICursor& next();

   operator bool () const
     {return isValid();}

   PCICursor& operator ++ ()
     {return next();}

   PCICursor& operator ++ (int i)
     {return next();}

   const PCIDeviceInfo & deviceAtCursor () const;

protected:

private:
   PCICursor (PCICursor &);
   PCICursor & operator = (PCICursor &);

   PCIBus::PCIDeviceList::const_iterator theIterator;

}; // end PCICursor class declaration

}; // end namespace
#endif